> ## Documentation Index
> Fetch the complete documentation index at: https://docs.firedrill.run/llms.txt
> Use this file to discover all available pages before exploring further.

# Read one Agent action



## OpenAPI

````yaml /api-reference/openapi.json get /v1/projects/{projectId}/authoring-sessions/{authoringSessionId}/actions/{agentActionId}
openapi: 3.1.0
info:
  title: Firedrill Control API
  version: 1.0.0
  description: >-
    The control plane for drills, drill runs, and the worlds they run in. Errors
    always carry the canonical envelope; unsafe operations require an
    Idempotency-Key; long work returns an operation resource.
servers:
  - url: https://api.firedrill.run
security:
  - controlCredential: []
paths:
  /v1/projects/{projectId}/authoring-sessions/{authoringSessionId}/actions/{agentActionId}:
    get:
      summary: Read one Agent action
      operationId: authoring.getAction
      parameters:
        - name: projectId
          in: path
          required: true
          schema:
            type: string
            pattern: ^prj_[0-9a-z]{12,32}$
        - name: authoringSessionId
          in: path
          required: true
          schema:
            type: string
            pattern: ^authsess_[0-9a-z]{12,32}$
        - name: agentActionId
          in: path
          required: true
          schema:
            type: string
            pattern: ^aact_[0-9a-z]{12,32}$
      responses:
        '200':
          description: Read one Agent action
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AgentActionResponse'
        default:
          description: Canonical error envelope
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorEnvelope'
components:
  schemas:
    AgentActionResponse:
      type: object
      properties:
        action:
          oneOf:
            - type: object
              properties:
                schemaVersion:
                  type: number
                  enum:
                    - 1
                agentActionId:
                  type: string
                  pattern: ^aact_[0-9a-z]{12,32}$
                authoringSessionId:
                  type: string
                  pattern: ^authsess_[0-9a-z]{12,32}$
                authoringTurnId:
                  type: string
                  pattern: ^aturn_[0-9a-z]{12,32}$
                organizationId:
                  type: string
                  pattern: ^org_[0-9a-z]{12,32}$
                projectId:
                  type: string
                  pattern: ^prj_[0-9a-z]{12,32}$
                summary:
                  type: string
                  minLength: 1
                  maxLength: 2000
                consequences:
                  minItems: 1
                  maxItems: 12
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 500
                digest:
                  type: string
                  pattern: ^sha256:[0-9a-f]{64}$
                state:
                  type: string
                  enum:
                    - proposed
                    - approved
                    - executing
                    - succeeded
                    - failed
                    - rejected
                    - expired
                version:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                expiresAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                approvedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                approvedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                rejectedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                finishedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                outcome:
                  type: object
                  properties:
                    toolSetupId:
                      type: string
                      pattern: ^setup_[0-9a-z]{12,32}$
                    sourceDraftId:
                      type: string
                      pattern: ^draft_[0-9a-z]{12,32}$
                    sourceDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    sourceDraftRevision:
                      type: integer
                      minimum: 1
                      maximum: 2147483647
                    buildAttemptId:
                      type: string
                      minLength: 1
                      maxLength: 255
                    operationId:
                      type: string
                      pattern: ^op_[0-9a-z]{12,32}$
                    environmentId:
                      type: string
                      pattern: ^env_[0-9a-z]{12,32}$
                    environmentVersion:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    buildHash:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    hostedRunId:
                      type: string
                      pattern: ^hrun_[0-9a-z]{12,32}$
                    sessionId:
                      type: string
                      pattern: ^ses_[0-9a-z]{12,32}$
                    runState:
                      type: string
                      enum:
                        - created
                        - awaiting_agent
                        - ready_to_seal
                        - sealed
                        - runner_failed
                        - cancelled
                        - aborted_before_start
                        - orchestration_failed
                    simulationPlanId:
                      type: string
                      pattern: ^simplan_[0-9a-z]{12,32}$
                    simulationPlanDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    simulationBatchId:
                      type: string
                      pattern: ^cisuite_[0-9a-z]{12,32}$
                    simulationBatchState:
                      type: string
                      enum:
                        - preparing
                        - running
                        - cancelling
                        - completed
                        - failed
                        - cancelled
                  additionalProperties: false
                error:
                  type: object
                  properties:
                    schemaVersion:
                      type: number
                      enum:
                        - 1
                    code:
                      type: string
                      pattern: ^[a-z][a-z0-9-]*\.[A-Z][A-Z0-9_]*$
                    source:
                      type: string
                      enum:
                        - framework
                        - world
                        - tool
                        - target
                        - assertion
                        - reporter
                        - control
                    message:
                      type: string
                      minLength: 1
                      maxLength: 4000
                    retryable:
                      type: boolean
                    correlationId:
                      type: string
                      pattern: ^corr_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                    issues:
                      default: []
                      type: array
                      items:
                        type: object
                        properties:
                          code:
                            type: string
                            minLength: 1
                            maxLength: 128
                          message:
                            type: string
                            minLength: 1
                            maxLength: 2000
                          path:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                - type: integer
                                  minimum: 0
                                  maximum: 9007199254740991
                          suggestion:
                            type: string
                            minLength: 1
                            maxLength: 4000
                        required:
                          - code
                          - message
                        additionalProperties: {}
                    details:
                      type: object
                      additionalProperties:
                        $ref: '#/components/schemas/AgentActionResponse___schema0'
                    evidence:
                      type: object
                      properties:
                        runId:
                          type: string
                          pattern: ^run_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                        sequence:
                          type: integer
                          minimum: 0
                          exclusiveMinimum: true
                          maximum: 9007199254740991
                      additionalProperties: {}
                  required:
                    - schemaVersion
                    - code
                    - source
                    - message
                    - retryable
                    - issues
                  additionalProperties: {}
                createdAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                updatedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                kind:
                  type: string
                  enum:
                    - tool_setup.create
                inputs:
                  type: object
                  properties:
                    name:
                      type: string
                      minLength: 1
                      maxLength: 160
                    tools:
                      minItems: 1
                      maxItems: 8
                      type: array
                      items:
                        type: object
                        properties:
                          libraryEntryId:
                            type: string
                            pattern: ^[a-z0-9][a-z0-9-]{0,79}$
                          expectedPackageArchiveDigest:
                            type: string
                            pattern: ^sha256:[0-9a-f]{64}$
                          initialState:
                            type: string
                            enum:
                              - starter
                              - empty
                          instanceId:
                            type: string
                            minLength: 1
                            maxLength: 96
                            pattern: ^[a-z][a-z0-9]*(?:[-_][a-z0-9]+)*$
                        required:
                          - libraryEntryId
                          - expectedPackageArchiveDigest
                          - initialState
                        additionalProperties: false
                  required:
                    - tools
                  additionalProperties: false
              required:
                - schemaVersion
                - agentActionId
                - authoringSessionId
                - authoringTurnId
                - organizationId
                - projectId
                - summary
                - consequences
                - digest
                - state
                - version
                - expiresAtMs
                - createdAtMs
                - updatedAtMs
                - kind
                - inputs
              additionalProperties: false
            - type: object
              properties:
                schemaVersion:
                  type: number
                  enum:
                    - 1
                agentActionId:
                  type: string
                  pattern: ^aact_[0-9a-z]{12,32}$
                authoringSessionId:
                  type: string
                  pattern: ^authsess_[0-9a-z]{12,32}$
                authoringTurnId:
                  type: string
                  pattern: ^aturn_[0-9a-z]{12,32}$
                organizationId:
                  type: string
                  pattern: ^org_[0-9a-z]{12,32}$
                projectId:
                  type: string
                  pattern: ^prj_[0-9a-z]{12,32}$
                summary:
                  type: string
                  minLength: 1
                  maxLength: 2000
                consequences:
                  minItems: 1
                  maxItems: 12
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 500
                digest:
                  type: string
                  pattern: ^sha256:[0-9a-f]{64}$
                state:
                  type: string
                  enum:
                    - proposed
                    - approved
                    - executing
                    - succeeded
                    - failed
                    - rejected
                    - expired
                version:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                expiresAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                approvedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                approvedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                rejectedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                finishedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                outcome:
                  type: object
                  properties:
                    toolSetupId:
                      type: string
                      pattern: ^setup_[0-9a-z]{12,32}$
                    sourceDraftId:
                      type: string
                      pattern: ^draft_[0-9a-z]{12,32}$
                    sourceDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    sourceDraftRevision:
                      type: integer
                      minimum: 1
                      maximum: 2147483647
                    buildAttemptId:
                      type: string
                      minLength: 1
                      maxLength: 255
                    operationId:
                      type: string
                      pattern: ^op_[0-9a-z]{12,32}$
                    environmentId:
                      type: string
                      pattern: ^env_[0-9a-z]{12,32}$
                    environmentVersion:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    buildHash:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    hostedRunId:
                      type: string
                      pattern: ^hrun_[0-9a-z]{12,32}$
                    sessionId:
                      type: string
                      pattern: ^ses_[0-9a-z]{12,32}$
                    runState:
                      type: string
                      enum:
                        - created
                        - awaiting_agent
                        - ready_to_seal
                        - sealed
                        - runner_failed
                        - cancelled
                        - aborted_before_start
                        - orchestration_failed
                    simulationPlanId:
                      type: string
                      pattern: ^simplan_[0-9a-z]{12,32}$
                    simulationPlanDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    simulationBatchId:
                      type: string
                      pattern: ^cisuite_[0-9a-z]{12,32}$
                    simulationBatchState:
                      type: string
                      enum:
                        - preparing
                        - running
                        - cancelling
                        - completed
                        - failed
                        - cancelled
                  additionalProperties: false
                error:
                  type: object
                  properties:
                    schemaVersion:
                      type: number
                      enum:
                        - 1
                    code:
                      type: string
                      pattern: ^[a-z][a-z0-9-]*\.[A-Z][A-Z0-9_]*$
                    source:
                      type: string
                      enum:
                        - framework
                        - world
                        - tool
                        - target
                        - assertion
                        - reporter
                        - control
                    message:
                      type: string
                      minLength: 1
                      maxLength: 4000
                    retryable:
                      type: boolean
                    correlationId:
                      type: string
                      pattern: ^corr_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                    issues:
                      default: []
                      type: array
                      items:
                        type: object
                        properties:
                          code:
                            type: string
                            minLength: 1
                            maxLength: 128
                          message:
                            type: string
                            minLength: 1
                            maxLength: 2000
                          path:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                - type: integer
                                  minimum: 0
                                  maximum: 9007199254740991
                          suggestion:
                            type: string
                            minLength: 1
                            maxLength: 4000
                        required:
                          - code
                          - message
                        additionalProperties: {}
                    details:
                      type: object
                      additionalProperties:
                        $ref: '#/components/schemas/AgentActionResponse___schema0'
                    evidence:
                      type: object
                      properties:
                        runId:
                          type: string
                          pattern: ^run_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                        sequence:
                          type: integer
                          minimum: 0
                          exclusiveMinimum: true
                          maximum: 9007199254740991
                      additionalProperties: {}
                  required:
                    - schemaVersion
                    - code
                    - source
                    - message
                    - retryable
                    - issues
                  additionalProperties: {}
                createdAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                updatedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                kind:
                  type: string
                  enum:
                    - environment.activate
                inputs:
                  type: object
                  properties:
                    environmentId:
                      type: string
                      pattern: ^env_[0-9a-z]{12,32}$
                    buildHash:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    expectedEnvironmentVersion:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                  required:
                    - environmentId
                    - buildHash
                    - expectedEnvironmentVersion
                  additionalProperties: false
              required:
                - schemaVersion
                - agentActionId
                - authoringSessionId
                - authoringTurnId
                - organizationId
                - projectId
                - summary
                - consequences
                - digest
                - state
                - version
                - expiresAtMs
                - createdAtMs
                - updatedAtMs
                - kind
                - inputs
              additionalProperties: false
            - type: object
              properties:
                schemaVersion:
                  type: number
                  enum:
                    - 1
                agentActionId:
                  type: string
                  pattern: ^aact_[0-9a-z]{12,32}$
                authoringSessionId:
                  type: string
                  pattern: ^authsess_[0-9a-z]{12,32}$
                authoringTurnId:
                  type: string
                  pattern: ^aturn_[0-9a-z]{12,32}$
                organizationId:
                  type: string
                  pattern: ^org_[0-9a-z]{12,32}$
                projectId:
                  type: string
                  pattern: ^prj_[0-9a-z]{12,32}$
                summary:
                  type: string
                  minLength: 1
                  maxLength: 2000
                consequences:
                  minItems: 1
                  maxItems: 12
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 500
                digest:
                  type: string
                  pattern: ^sha256:[0-9a-f]{64}$
                state:
                  type: string
                  enum:
                    - proposed
                    - approved
                    - executing
                    - succeeded
                    - failed
                    - rejected
                    - expired
                version:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                expiresAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                approvedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                approvedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                rejectedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                finishedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                outcome:
                  type: object
                  properties:
                    toolSetupId:
                      type: string
                      pattern: ^setup_[0-9a-z]{12,32}$
                    sourceDraftId:
                      type: string
                      pattern: ^draft_[0-9a-z]{12,32}$
                    sourceDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    sourceDraftRevision:
                      type: integer
                      minimum: 1
                      maximum: 2147483647
                    buildAttemptId:
                      type: string
                      minLength: 1
                      maxLength: 255
                    operationId:
                      type: string
                      pattern: ^op_[0-9a-z]{12,32}$
                    environmentId:
                      type: string
                      pattern: ^env_[0-9a-z]{12,32}$
                    environmentVersion:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    buildHash:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    hostedRunId:
                      type: string
                      pattern: ^hrun_[0-9a-z]{12,32}$
                    sessionId:
                      type: string
                      pattern: ^ses_[0-9a-z]{12,32}$
                    runState:
                      type: string
                      enum:
                        - created
                        - awaiting_agent
                        - ready_to_seal
                        - sealed
                        - runner_failed
                        - cancelled
                        - aborted_before_start
                        - orchestration_failed
                    simulationPlanId:
                      type: string
                      pattern: ^simplan_[0-9a-z]{12,32}$
                    simulationPlanDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    simulationBatchId:
                      type: string
                      pattern: ^cisuite_[0-9a-z]{12,32}$
                    simulationBatchState:
                      type: string
                      enum:
                        - preparing
                        - running
                        - cancelling
                        - completed
                        - failed
                        - cancelled
                  additionalProperties: false
                error:
                  type: object
                  properties:
                    schemaVersion:
                      type: number
                      enum:
                        - 1
                    code:
                      type: string
                      pattern: ^[a-z][a-z0-9-]*\.[A-Z][A-Z0-9_]*$
                    source:
                      type: string
                      enum:
                        - framework
                        - world
                        - tool
                        - target
                        - assertion
                        - reporter
                        - control
                    message:
                      type: string
                      minLength: 1
                      maxLength: 4000
                    retryable:
                      type: boolean
                    correlationId:
                      type: string
                      pattern: ^corr_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                    issues:
                      default: []
                      type: array
                      items:
                        type: object
                        properties:
                          code:
                            type: string
                            minLength: 1
                            maxLength: 128
                          message:
                            type: string
                            minLength: 1
                            maxLength: 2000
                          path:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                - type: integer
                                  minimum: 0
                                  maximum: 9007199254740991
                          suggestion:
                            type: string
                            minLength: 1
                            maxLength: 4000
                        required:
                          - code
                          - message
                        additionalProperties: {}
                    details:
                      type: object
                      additionalProperties:
                        $ref: '#/components/schemas/AgentActionResponse___schema0'
                    evidence:
                      type: object
                      properties:
                        runId:
                          type: string
                          pattern: ^run_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                        sequence:
                          type: integer
                          minimum: 0
                          exclusiveMinimum: true
                          maximum: 9007199254740991
                      additionalProperties: {}
                  required:
                    - schemaVersion
                    - code
                    - source
                    - message
                    - retryable
                    - issues
                  additionalProperties: {}
                createdAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                updatedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                kind:
                  type: string
                  enum:
                    - run.rerun
                inputs:
                  type: object
                  properties:
                    hostedRunId:
                      type: string
                      pattern: ^hrun_[0-9a-z]{12,32}$
                  required:
                    - hostedRunId
                  additionalProperties: false
              required:
                - schemaVersion
                - agentActionId
                - authoringSessionId
                - authoringTurnId
                - organizationId
                - projectId
                - summary
                - consequences
                - digest
                - state
                - version
                - expiresAtMs
                - createdAtMs
                - updatedAtMs
                - kind
                - inputs
              additionalProperties: false
            - type: object
              properties:
                schemaVersion:
                  type: number
                  enum:
                    - 1
                agentActionId:
                  type: string
                  pattern: ^aact_[0-9a-z]{12,32}$
                authoringSessionId:
                  type: string
                  pattern: ^authsess_[0-9a-z]{12,32}$
                authoringTurnId:
                  type: string
                  pattern: ^aturn_[0-9a-z]{12,32}$
                organizationId:
                  type: string
                  pattern: ^org_[0-9a-z]{12,32}$
                projectId:
                  type: string
                  pattern: ^prj_[0-9a-z]{12,32}$
                summary:
                  type: string
                  minLength: 1
                  maxLength: 2000
                consequences:
                  minItems: 1
                  maxItems: 12
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 500
                digest:
                  type: string
                  pattern: ^sha256:[0-9a-f]{64}$
                state:
                  type: string
                  enum:
                    - proposed
                    - approved
                    - executing
                    - succeeded
                    - failed
                    - rejected
                    - expired
                version:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                expiresAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                approvedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                approvedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                rejectedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                finishedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                outcome:
                  type: object
                  properties:
                    toolSetupId:
                      type: string
                      pattern: ^setup_[0-9a-z]{12,32}$
                    sourceDraftId:
                      type: string
                      pattern: ^draft_[0-9a-z]{12,32}$
                    sourceDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    sourceDraftRevision:
                      type: integer
                      minimum: 1
                      maximum: 2147483647
                    buildAttemptId:
                      type: string
                      minLength: 1
                      maxLength: 255
                    operationId:
                      type: string
                      pattern: ^op_[0-9a-z]{12,32}$
                    environmentId:
                      type: string
                      pattern: ^env_[0-9a-z]{12,32}$
                    environmentVersion:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    buildHash:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    hostedRunId:
                      type: string
                      pattern: ^hrun_[0-9a-z]{12,32}$
                    sessionId:
                      type: string
                      pattern: ^ses_[0-9a-z]{12,32}$
                    runState:
                      type: string
                      enum:
                        - created
                        - awaiting_agent
                        - ready_to_seal
                        - sealed
                        - runner_failed
                        - cancelled
                        - aborted_before_start
                        - orchestration_failed
                    simulationPlanId:
                      type: string
                      pattern: ^simplan_[0-9a-z]{12,32}$
                    simulationPlanDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    simulationBatchId:
                      type: string
                      pattern: ^cisuite_[0-9a-z]{12,32}$
                    simulationBatchState:
                      type: string
                      enum:
                        - preparing
                        - running
                        - cancelling
                        - completed
                        - failed
                        - cancelled
                  additionalProperties: false
                error:
                  type: object
                  properties:
                    schemaVersion:
                      type: number
                      enum:
                        - 1
                    code:
                      type: string
                      pattern: ^[a-z][a-z0-9-]*\.[A-Z][A-Z0-9_]*$
                    source:
                      type: string
                      enum:
                        - framework
                        - world
                        - tool
                        - target
                        - assertion
                        - reporter
                        - control
                    message:
                      type: string
                      minLength: 1
                      maxLength: 4000
                    retryable:
                      type: boolean
                    correlationId:
                      type: string
                      pattern: ^corr_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                    issues:
                      default: []
                      type: array
                      items:
                        type: object
                        properties:
                          code:
                            type: string
                            minLength: 1
                            maxLength: 128
                          message:
                            type: string
                            minLength: 1
                            maxLength: 2000
                          path:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                - type: integer
                                  minimum: 0
                                  maximum: 9007199254740991
                          suggestion:
                            type: string
                            minLength: 1
                            maxLength: 4000
                        required:
                          - code
                          - message
                        additionalProperties: {}
                    details:
                      type: object
                      additionalProperties:
                        $ref: '#/components/schemas/AgentActionResponse___schema0'
                    evidence:
                      type: object
                      properties:
                        runId:
                          type: string
                          pattern: ^run_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                        sequence:
                          type: integer
                          minimum: 0
                          exclusiveMinimum: true
                          maximum: 9007199254740991
                      additionalProperties: {}
                  required:
                    - schemaVersion
                    - code
                    - source
                    - message
                    - retryable
                    - issues
                  additionalProperties: {}
                createdAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                updatedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                kind:
                  type: string
                  enum:
                    - run.cancel
                inputs:
                  type: object
                  properties:
                    hostedRunId:
                      type: string
                      pattern: ^hrun_[0-9a-z]{12,32}$
                    expectedRevision:
                      type: integer
                      minimum: 0
                      exclusiveMinimum: true
                      maximum: 9007199254740991
                    reason:
                      type: string
                      minLength: 1
                      maxLength: 1000
                  required:
                    - hostedRunId
                    - expectedRevision
                    - reason
                  additionalProperties: false
              required:
                - schemaVersion
                - agentActionId
                - authoringSessionId
                - authoringTurnId
                - organizationId
                - projectId
                - summary
                - consequences
                - digest
                - state
                - version
                - expiresAtMs
                - createdAtMs
                - updatedAtMs
                - kind
                - inputs
              additionalProperties: false
            - type: object
              properties:
                schemaVersion:
                  type: number
                  enum:
                    - 1
                agentActionId:
                  type: string
                  pattern: ^aact_[0-9a-z]{12,32}$
                authoringSessionId:
                  type: string
                  pattern: ^authsess_[0-9a-z]{12,32}$
                authoringTurnId:
                  type: string
                  pattern: ^aturn_[0-9a-z]{12,32}$
                organizationId:
                  type: string
                  pattern: ^org_[0-9a-z]{12,32}$
                projectId:
                  type: string
                  pattern: ^prj_[0-9a-z]{12,32}$
                summary:
                  type: string
                  minLength: 1
                  maxLength: 2000
                consequences:
                  minItems: 1
                  maxItems: 12
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 500
                digest:
                  type: string
                  pattern: ^sha256:[0-9a-f]{64}$
                state:
                  type: string
                  enum:
                    - proposed
                    - approved
                    - executing
                    - succeeded
                    - failed
                    - rejected
                    - expired
                version:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                expiresAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                approvedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                approvedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                rejectedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                finishedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                outcome:
                  type: object
                  properties:
                    toolSetupId:
                      type: string
                      pattern: ^setup_[0-9a-z]{12,32}$
                    sourceDraftId:
                      type: string
                      pattern: ^draft_[0-9a-z]{12,32}$
                    sourceDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    sourceDraftRevision:
                      type: integer
                      minimum: 1
                      maximum: 2147483647
                    buildAttemptId:
                      type: string
                      minLength: 1
                      maxLength: 255
                    operationId:
                      type: string
                      pattern: ^op_[0-9a-z]{12,32}$
                    environmentId:
                      type: string
                      pattern: ^env_[0-9a-z]{12,32}$
                    environmentVersion:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    buildHash:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    hostedRunId:
                      type: string
                      pattern: ^hrun_[0-9a-z]{12,32}$
                    sessionId:
                      type: string
                      pattern: ^ses_[0-9a-z]{12,32}$
                    runState:
                      type: string
                      enum:
                        - created
                        - awaiting_agent
                        - ready_to_seal
                        - sealed
                        - runner_failed
                        - cancelled
                        - aborted_before_start
                        - orchestration_failed
                    simulationPlanId:
                      type: string
                      pattern: ^simplan_[0-9a-z]{12,32}$
                    simulationPlanDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    simulationBatchId:
                      type: string
                      pattern: ^cisuite_[0-9a-z]{12,32}$
                    simulationBatchState:
                      type: string
                      enum:
                        - preparing
                        - running
                        - cancelling
                        - completed
                        - failed
                        - cancelled
                  additionalProperties: false
                error:
                  type: object
                  properties:
                    schemaVersion:
                      type: number
                      enum:
                        - 1
                    code:
                      type: string
                      pattern: ^[a-z][a-z0-9-]*\.[A-Z][A-Z0-9_]*$
                    source:
                      type: string
                      enum:
                        - framework
                        - world
                        - tool
                        - target
                        - assertion
                        - reporter
                        - control
                    message:
                      type: string
                      minLength: 1
                      maxLength: 4000
                    retryable:
                      type: boolean
                    correlationId:
                      type: string
                      pattern: ^corr_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                    issues:
                      default: []
                      type: array
                      items:
                        type: object
                        properties:
                          code:
                            type: string
                            minLength: 1
                            maxLength: 128
                          message:
                            type: string
                            minLength: 1
                            maxLength: 2000
                          path:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                - type: integer
                                  minimum: 0
                                  maximum: 9007199254740991
                          suggestion:
                            type: string
                            minLength: 1
                            maxLength: 4000
                        required:
                          - code
                          - message
                        additionalProperties: {}
                    details:
                      type: object
                      additionalProperties:
                        $ref: '#/components/schemas/AgentActionResponse___schema0'
                    evidence:
                      type: object
                      properties:
                        runId:
                          type: string
                          pattern: ^run_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                        sequence:
                          type: integer
                          minimum: 0
                          exclusiveMinimum: true
                          maximum: 9007199254740991
                      additionalProperties: {}
                  required:
                    - schemaVersion
                    - code
                    - source
                    - message
                    - retryable
                    - issues
                  additionalProperties: {}
                createdAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                updatedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                kind:
                  type: string
                  enum:
                    - simulation.start
                inputs:
                  type: object
                  properties:
                    environmentId:
                      type: string
                      pattern: ^env_[0-9a-z]{12,32}$
                    buildHash:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    drillIds:
                      minItems: 1
                      maxItems: 10000
                      type: array
                      items:
                        type: string
                        minLength: 1
                        maxLength: 96
                        pattern: ^[a-z][a-z0-9]*(?:[-_][a-z0-9]+)*$
                    seeds:
                      minItems: 1
                      maxItems: 10000
                      type: array
                      items:
                        type: string
                        pattern: ^(0|[1-9]\d{0,19})$
                    repetitions:
                      type: integer
                      minimum: 0
                      exclusiveMinimum: true
                      maximum: 10000
                    concurrency:
                      default: 1
                      type: integer
                      minimum: 0
                      exclusiveMinimum: true
                      maximum: 64
                    retries:
                      default: 0
                      type: integer
                      minimum: 0
                      maximum: 10
                  required:
                    - environmentId
                    - buildHash
                    - drillIds
                    - concurrency
                    - retries
                  additionalProperties: false
                simulationPreview:
                  type: object
                  properties:
                    planDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    logicalCases:
                      type: integer
                      minimum: 1
                      maximum: 10000
                    maxAttempts:
                      type: integer
                      minimum: 1
                      maximum: 110000
                    concurrency:
                      type: integer
                      minimum: 1
                      maximum: 64
                    retries:
                      type: integer
                      minimum: 0
                      maximum: 10
                    longestCaseTimeoutMs:
                      type: integer
                      minimum: 1
                      maximum: 86400000
                    drills:
                      minItems: 1
                      maxItems: 200
                      type: array
                      items:
                        type: object
                        properties:
                          drillId:
                            type: string
                            minLength: 1
                            maxLength: 255
                          targetId:
                            type: string
                            minLength: 1
                            maxLength: 255
                          classification:
                            type: string
                            enum:
                              - contract
                              - safety
                              - quality
                          cases:
                            type: integer
                            minimum: 1
                            maximum: 10000
                          timeoutMs:
                            type: integer
                            minimum: 1
                            maximum: 86400000
                        required:
                          - drillId
                          - targetId
                          - classification
                          - cases
                          - timeoutMs
                        additionalProperties: false
                    drillsOmitted:
                      type: integer
                      minimum: 1
                      maximum: 9007199254740991
                  required:
                    - planDigest
                    - logicalCases
                    - maxAttempts
                    - concurrency
                    - retries
                    - longestCaseTimeoutMs
                    - drills
                  additionalProperties: false
              required:
                - schemaVersion
                - agentActionId
                - authoringSessionId
                - authoringTurnId
                - organizationId
                - projectId
                - summary
                - consequences
                - digest
                - state
                - version
                - expiresAtMs
                - createdAtMs
                - updatedAtMs
                - kind
                - inputs
                - simulationPreview
              additionalProperties: false
            - type: object
              properties:
                schemaVersion:
                  type: number
                  enum:
                    - 1
                agentActionId:
                  type: string
                  pattern: ^aact_[0-9a-z]{12,32}$
                authoringSessionId:
                  type: string
                  pattern: ^authsess_[0-9a-z]{12,32}$
                authoringTurnId:
                  type: string
                  pattern: ^aturn_[0-9a-z]{12,32}$
                organizationId:
                  type: string
                  pattern: ^org_[0-9a-z]{12,32}$
                projectId:
                  type: string
                  pattern: ^prj_[0-9a-z]{12,32}$
                summary:
                  type: string
                  minLength: 1
                  maxLength: 2000
                consequences:
                  minItems: 1
                  maxItems: 12
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 500
                digest:
                  type: string
                  pattern: ^sha256:[0-9a-f]{64}$
                state:
                  type: string
                  enum:
                    - proposed
                    - approved
                    - executing
                    - succeeded
                    - failed
                    - rejected
                    - expired
                version:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                expiresAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                approvedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                approvedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                rejectedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                finishedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                outcome:
                  type: object
                  properties:
                    toolSetupId:
                      type: string
                      pattern: ^setup_[0-9a-z]{12,32}$
                    sourceDraftId:
                      type: string
                      pattern: ^draft_[0-9a-z]{12,32}$
                    sourceDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    sourceDraftRevision:
                      type: integer
                      minimum: 1
                      maximum: 2147483647
                    buildAttemptId:
                      type: string
                      minLength: 1
                      maxLength: 255
                    operationId:
                      type: string
                      pattern: ^op_[0-9a-z]{12,32}$
                    environmentId:
                      type: string
                      pattern: ^env_[0-9a-z]{12,32}$
                    environmentVersion:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    buildHash:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    hostedRunId:
                      type: string
                      pattern: ^hrun_[0-9a-z]{12,32}$
                    sessionId:
                      type: string
                      pattern: ^ses_[0-9a-z]{12,32}$
                    runState:
                      type: string
                      enum:
                        - created
                        - awaiting_agent
                        - ready_to_seal
                        - sealed
                        - runner_failed
                        - cancelled
                        - aborted_before_start
                        - orchestration_failed
                    simulationPlanId:
                      type: string
                      pattern: ^simplan_[0-9a-z]{12,32}$
                    simulationPlanDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    simulationBatchId:
                      type: string
                      pattern: ^cisuite_[0-9a-z]{12,32}$
                    simulationBatchState:
                      type: string
                      enum:
                        - preparing
                        - running
                        - cancelling
                        - completed
                        - failed
                        - cancelled
                  additionalProperties: false
                error:
                  type: object
                  properties:
                    schemaVersion:
                      type: number
                      enum:
                        - 1
                    code:
                      type: string
                      pattern: ^[a-z][a-z0-9-]*\.[A-Z][A-Z0-9_]*$
                    source:
                      type: string
                      enum:
                        - framework
                        - world
                        - tool
                        - target
                        - assertion
                        - reporter
                        - control
                    message:
                      type: string
                      minLength: 1
                      maxLength: 4000
                    retryable:
                      type: boolean
                    correlationId:
                      type: string
                      pattern: ^corr_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                    issues:
                      default: []
                      type: array
                      items:
                        type: object
                        properties:
                          code:
                            type: string
                            minLength: 1
                            maxLength: 128
                          message:
                            type: string
                            minLength: 1
                            maxLength: 2000
                          path:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                - type: integer
                                  minimum: 0
                                  maximum: 9007199254740991
                          suggestion:
                            type: string
                            minLength: 1
                            maxLength: 4000
                        required:
                          - code
                          - message
                        additionalProperties: {}
                    details:
                      type: object
                      additionalProperties:
                        $ref: '#/components/schemas/AgentActionResponse___schema0'
                    evidence:
                      type: object
                      properties:
                        runId:
                          type: string
                          pattern: ^run_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                        sequence:
                          type: integer
                          minimum: 0
                          exclusiveMinimum: true
                          maximum: 9007199254740991
                      additionalProperties: {}
                  required:
                    - schemaVersion
                    - code
                    - source
                    - message
                    - retryable
                    - issues
                  additionalProperties: {}
                createdAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                updatedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                kind:
                  type: string
                  enum:
                    - simulation.cancel
                inputs:
                  type: object
                  properties:
                    batchId:
                      type: string
                      pattern: ^cisuite_[0-9a-z]{12,32}$
                    expectedVersion:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    reason:
                      type: string
                      minLength: 1
                      maxLength: 1000
                  required:
                    - batchId
                    - expectedVersion
                    - reason
                  additionalProperties: false
              required:
                - schemaVersion
                - agentActionId
                - authoringSessionId
                - authoringTurnId
                - organizationId
                - projectId
                - summary
                - consequences
                - digest
                - state
                - version
                - expiresAtMs
                - createdAtMs
                - updatedAtMs
                - kind
                - inputs
              additionalProperties: false
            - type: object
              properties:
                schemaVersion:
                  type: number
                  enum:
                    - 1
                agentActionId:
                  type: string
                  pattern: ^aact_[0-9a-z]{12,32}$
                authoringSessionId:
                  type: string
                  pattern: ^authsess_[0-9a-z]{12,32}$
                authoringTurnId:
                  type: string
                  pattern: ^aturn_[0-9a-z]{12,32}$
                organizationId:
                  type: string
                  pattern: ^org_[0-9a-z]{12,32}$
                projectId:
                  type: string
                  pattern: ^prj_[0-9a-z]{12,32}$
                summary:
                  type: string
                  minLength: 1
                  maxLength: 2000
                consequences:
                  minItems: 1
                  maxItems: 12
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 500
                digest:
                  type: string
                  pattern: ^sha256:[0-9a-f]{64}$
                state:
                  type: string
                  enum:
                    - proposed
                    - approved
                    - executing
                    - succeeded
                    - failed
                    - rejected
                    - expired
                version:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                expiresAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                approvedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                approvedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                rejectedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                finishedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                outcome:
                  type: object
                  properties:
                    toolSetupId:
                      type: string
                      pattern: ^setup_[0-9a-z]{12,32}$
                    sourceDraftId:
                      type: string
                      pattern: ^draft_[0-9a-z]{12,32}$
                    sourceDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    sourceDraftRevision:
                      type: integer
                      minimum: 1
                      maximum: 2147483647
                    buildAttemptId:
                      type: string
                      minLength: 1
                      maxLength: 255
                    operationId:
                      type: string
                      pattern: ^op_[0-9a-z]{12,32}$
                    environmentId:
                      type: string
                      pattern: ^env_[0-9a-z]{12,32}$
                    environmentVersion:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    buildHash:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    hostedRunId:
                      type: string
                      pattern: ^hrun_[0-9a-z]{12,32}$
                    sessionId:
                      type: string
                      pattern: ^ses_[0-9a-z]{12,32}$
                    runState:
                      type: string
                      enum:
                        - created
                        - awaiting_agent
                        - ready_to_seal
                        - sealed
                        - runner_failed
                        - cancelled
                        - aborted_before_start
                        - orchestration_failed
                    simulationPlanId:
                      type: string
                      pattern: ^simplan_[0-9a-z]{12,32}$
                    simulationPlanDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    simulationBatchId:
                      type: string
                      pattern: ^cisuite_[0-9a-z]{12,32}$
                    simulationBatchState:
                      type: string
                      enum:
                        - preparing
                        - running
                        - cancelling
                        - completed
                        - failed
                        - cancelled
                  additionalProperties: false
                error:
                  type: object
                  properties:
                    schemaVersion:
                      type: number
                      enum:
                        - 1
                    code:
                      type: string
                      pattern: ^[a-z][a-z0-9-]*\.[A-Z][A-Z0-9_]*$
                    source:
                      type: string
                      enum:
                        - framework
                        - world
                        - tool
                        - target
                        - assertion
                        - reporter
                        - control
                    message:
                      type: string
                      minLength: 1
                      maxLength: 4000
                    retryable:
                      type: boolean
                    correlationId:
                      type: string
                      pattern: ^corr_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                    issues:
                      default: []
                      type: array
                      items:
                        type: object
                        properties:
                          code:
                            type: string
                            minLength: 1
                            maxLength: 128
                          message:
                            type: string
                            minLength: 1
                            maxLength: 2000
                          path:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                - type: integer
                                  minimum: 0
                                  maximum: 9007199254740991
                          suggestion:
                            type: string
                            minLength: 1
                            maxLength: 4000
                        required:
                          - code
                          - message
                        additionalProperties: {}
                    details:
                      type: object
                      additionalProperties:
                        $ref: '#/components/schemas/AgentActionResponse___schema0'
                    evidence:
                      type: object
                      properties:
                        runId:
                          type: string
                          pattern: ^run_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                        sequence:
                          type: integer
                          minimum: 0
                          exclusiveMinimum: true
                          maximum: 9007199254740991
                      additionalProperties: {}
                  required:
                    - schemaVersion
                    - code
                    - source
                    - message
                    - retryable
                    - issues
                  additionalProperties: {}
                createdAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                updatedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                fileChanges:
                  minItems: 1
                  maxItems: 200
                  type: array
                  items:
                    type: object
                    properties:
                      path:
                        type: string
                        minLength: 1
                        maxLength: 512
                      change:
                        type: string
                        enum:
                          - added
                          - modified
                          - deleted
                      bytes:
                        type: integer
                        minimum: 0
                        maximum: 262144
                    required:
                      - path
                      - change
                      - bytes
                    additionalProperties: false
                sourceCheck:
                  type: object
                  properties:
                    status:
                      type: string
                      enum:
                        - passed
                        - failed
                        - not_run
                    summary:
                      type: string
                      minLength: 1
                      maxLength: 500
                    diagnostics:
                      maxItems: 50
                      type: array
                      items:
                        type: object
                        properties:
                          code:
                            type: string
                            minLength: 1
                            maxLength: 40
                          severity:
                            type: string
                            enum:
                              - error
                              - warning
                              - info
                          message:
                            type: string
                            minLength: 1
                            maxLength: 500
                          path:
                            type: string
                            minLength: 1
                            maxLength: 512
                        required:
                          - code
                          - message
                        additionalProperties: false
                  required:
                    - status
                    - summary
                    - diagnostics
                  additionalProperties: false
                inputsOmitted:
                  type: boolean
                  enum:
                    - true
                inputsOmittedReason:
                  type: string
                  enum:
                    - permission
                    - draft_deleted
                kind:
                  type: string
                  enum:
                    - source_draft.create
                inputs:
                  type: object
                  properties:
                    name:
                      type: string
                      minLength: 1
                      maxLength: 160
                    files:
                      minItems: 1
                      maxItems: 200
                      type: array
                      items:
                        type: object
                        properties:
                          path:
                            type: string
                            minLength: 1
                            maxLength: 512
                          content:
                            type: string
                        required:
                          - path
                          - content
                        additionalProperties: false
                  required:
                    - name
                    - files
                  additionalProperties: false
              required:
                - schemaVersion
                - agentActionId
                - authoringSessionId
                - authoringTurnId
                - organizationId
                - projectId
                - summary
                - consequences
                - digest
                - state
                - version
                - expiresAtMs
                - createdAtMs
                - updatedAtMs
                - fileChanges
                - sourceCheck
                - kind
              additionalProperties: false
            - type: object
              properties:
                schemaVersion:
                  type: number
                  enum:
                    - 1
                agentActionId:
                  type: string
                  pattern: ^aact_[0-9a-z]{12,32}$
                authoringSessionId:
                  type: string
                  pattern: ^authsess_[0-9a-z]{12,32}$
                authoringTurnId:
                  type: string
                  pattern: ^aturn_[0-9a-z]{12,32}$
                organizationId:
                  type: string
                  pattern: ^org_[0-9a-z]{12,32}$
                projectId:
                  type: string
                  pattern: ^prj_[0-9a-z]{12,32}$
                summary:
                  type: string
                  minLength: 1
                  maxLength: 2000
                consequences:
                  minItems: 1
                  maxItems: 12
                  type: array
                  items:
                    type: string
                    minLength: 1
                    maxLength: 500
                digest:
                  type: string
                  pattern: ^sha256:[0-9a-f]{64}$
                state:
                  type: string
                  enum:
                    - proposed
                    - approved
                    - executing
                    - succeeded
                    - failed
                    - rejected
                    - expired
                version:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                expiresAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                approvedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                approvedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                rejectedBy:
                  type: string
                  pattern: ^usr_[0-9a-z]{12,32}$
                finishedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                outcome:
                  type: object
                  properties:
                    toolSetupId:
                      type: string
                      pattern: ^setup_[0-9a-z]{12,32}$
                    sourceDraftId:
                      type: string
                      pattern: ^draft_[0-9a-z]{12,32}$
                    sourceDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    sourceDraftRevision:
                      type: integer
                      minimum: 1
                      maximum: 2147483647
                    buildAttemptId:
                      type: string
                      minLength: 1
                      maxLength: 255
                    operationId:
                      type: string
                      pattern: ^op_[0-9a-z]{12,32}$
                    environmentId:
                      type: string
                      pattern: ^env_[0-9a-z]{12,32}$
                    environmentVersion:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    buildHash:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    hostedRunId:
                      type: string
                      pattern: ^hrun_[0-9a-z]{12,32}$
                    sessionId:
                      type: string
                      pattern: ^ses_[0-9a-z]{12,32}$
                    runState:
                      type: string
                      enum:
                        - created
                        - awaiting_agent
                        - ready_to_seal
                        - sealed
                        - runner_failed
                        - cancelled
                        - aborted_before_start
                        - orchestration_failed
                    simulationPlanId:
                      type: string
                      pattern: ^simplan_[0-9a-z]{12,32}$
                    simulationPlanDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    simulationBatchId:
                      type: string
                      pattern: ^cisuite_[0-9a-z]{12,32}$
                    simulationBatchState:
                      type: string
                      enum:
                        - preparing
                        - running
                        - cancelling
                        - completed
                        - failed
                        - cancelled
                  additionalProperties: false
                error:
                  type: object
                  properties:
                    schemaVersion:
                      type: number
                      enum:
                        - 1
                    code:
                      type: string
                      pattern: ^[a-z][a-z0-9-]*\.[A-Z][A-Z0-9_]*$
                    source:
                      type: string
                      enum:
                        - framework
                        - world
                        - tool
                        - target
                        - assertion
                        - reporter
                        - control
                    message:
                      type: string
                      minLength: 1
                      maxLength: 4000
                    retryable:
                      type: boolean
                    correlationId:
                      type: string
                      pattern: ^corr_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                    issues:
                      default: []
                      type: array
                      items:
                        type: object
                        properties:
                          code:
                            type: string
                            minLength: 1
                            maxLength: 128
                          message:
                            type: string
                            minLength: 1
                            maxLength: 2000
                          path:
                            type: array
                            items:
                              anyOf:
                                - type: string
                                - type: integer
                                  minimum: 0
                                  maximum: 9007199254740991
                          suggestion:
                            type: string
                            minLength: 1
                            maxLength: 4000
                        required:
                          - code
                          - message
                        additionalProperties: {}
                    details:
                      type: object
                      additionalProperties:
                        $ref: '#/components/schemas/AgentActionResponse___schema0'
                    evidence:
                      type: object
                      properties:
                        runId:
                          type: string
                          pattern: ^run_[A-Za-z0-9][A-Za-z0-9_-]{5,95}$
                        sequence:
                          type: integer
                          minimum: 0
                          exclusiveMinimum: true
                          maximum: 9007199254740991
                      additionalProperties: {}
                  required:
                    - schemaVersion
                    - code
                    - source
                    - message
                    - retryable
                    - issues
                  additionalProperties: {}
                createdAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                updatedAtMs:
                  type: integer
                  minimum: -9007199254740991
                  maximum: 9007199254740991
                fileChanges:
                  minItems: 1
                  maxItems: 200
                  type: array
                  items:
                    type: object
                    properties:
                      path:
                        type: string
                        minLength: 1
                        maxLength: 512
                      change:
                        type: string
                        enum:
                          - added
                          - modified
                          - deleted
                      bytes:
                        type: integer
                        minimum: 0
                        maximum: 262144
                    required:
                      - path
                      - change
                      - bytes
                    additionalProperties: false
                sourceCheck:
                  type: object
                  properties:
                    status:
                      type: string
                      enum:
                        - passed
                        - failed
                        - not_run
                    summary:
                      type: string
                      minLength: 1
                      maxLength: 500
                    diagnostics:
                      maxItems: 50
                      type: array
                      items:
                        type: object
                        properties:
                          code:
                            type: string
                            minLength: 1
                            maxLength: 40
                          severity:
                            type: string
                            enum:
                              - error
                              - warning
                              - info
                          message:
                            type: string
                            minLength: 1
                            maxLength: 500
                          path:
                            type: string
                            minLength: 1
                            maxLength: 512
                        required:
                          - code
                          - message
                        additionalProperties: false
                  required:
                    - status
                    - summary
                    - diagnostics
                  additionalProperties: false
                inputsOmitted:
                  type: boolean
                  enum:
                    - true
                inputsOmittedReason:
                  type: string
                  enum:
                    - permission
                    - draft_deleted
                kind:
                  type: string
                  enum:
                    - source_draft.revise
                inputs:
                  type: object
                  properties:
                    sourceDraftId:
                      type: string
                      pattern: ^draft_[0-9a-z]{12,32}$
                    expectedVersion:
                      type: integer
                      minimum: -9007199254740991
                      maximum: 9007199254740991
                    expectedSourceDigest:
                      type: string
                      pattern: ^sha256:[0-9a-f]{64}$
                    files:
                      minItems: 1
                      maxItems: 200
                      type: array
                      items:
                        type: object
                        properties:
                          path:
                            type: string
                            minLength: 1
                            maxLength: 512
                          content:
                            nullable: true
                            type: string
                        required:
                          - path
                          - content
                        additionalProperties: false
                  required:
                    - sourceDraftId
                    - expectedVersion
                    - expectedSourceDigest
                    - files
                  additionalProperties: false
                baseRevision:
                  type: integer
                  minimum: 1
                  maximum: 2147483647
              required:
                - schemaVersion
                - agentActionId
                - authoringSessionId
                - authoringTurnId
                - organizationId
                - projectId
                - summary
                - consequences
                - digest
                - state
                - version
                - expiresAtMs
                - createdAtMs
                - updatedAtMs
                - fileChanges
                - sourceCheck
                - kind
                - baseRevision
              additionalProperties: false
      required:
        - action
      additionalProperties: false
    ErrorEnvelope:
      type: object
      properties:
        code:
          type: string
          pattern: ^(control|world)\.[A-Z][A-Z0-9]*(_[A-Z0-9]+)*$
        message:
          type: string
          minLength: 1
        correlationId:
          type: string
          minLength: 1
        retryable:
          type: boolean
        retryAfterMs:
          type: integer
          exclusiveMinimum: 0
          maximum: 9007199254740991
        operationId:
          type: string
        source:
          type: string
          enum:
            - platform
            - simulated_provider
        issues:
          type: array
          items:
            type: object
            properties:
              path:
                type: string
              code:
                type: string
              message:
                type: string
            required:
              - path
              - code
              - message
            additionalProperties: false
        details:
          type: object
          propertyNames:
            type: string
          additionalProperties: {}
        evidence:
          type: object
          properties:
            sessionId:
              type: string
            runId:
              type: string
            journalSeq:
              type: integer
              minimum: 0
              maximum: 9007199254740991
            buildHash:
              type: string
          additionalProperties: false
      required:
        - code
        - message
        - correlationId
        - retryable
        - source
      additionalProperties: true
    AgentActionResponse___schema0:
      description: Any JSON-compatible value
  securitySchemes:
    controlCredential:
      type: http
      scheme: bearer
      description: Opaque control credential

````